--- orig/u-boot-master/tools/kwboot.c   2022-01-24 16:39:28.000000000 +0100
+++ u-boot-master/tools/kwboot.c        2022-01-28 09:09:48.238197038 +0100
@@ -1482,6 +1482,8 @@
        }
 }
 
+static int fix_crc = 0;
+
 static int
 kwboot_img_patch(void *img, size_t *size, int baudrate)
 {
@@ -1513,12 +1515,10 @@
                goto err;
 
        srcaddr = le32_to_cpu(hdr->srcaddr);
-
        switch (hdr->blockid) {
        case IBR_HDR_SATA_ID:
                if (srcaddr < 1)
                        goto err;
-
                hdr->srcaddr = cpu_to_le32((srcaddr - 1) * 512);
                break;
 
@@ -1545,8 +1545,17 @@
                goto err;
 
        if (kwboot_img_csum32(img) != *kwboot_img_csum32_ptr(img))
-               goto err;
-
+       {
+               if( fix_crc )
+               {
+                       kwboot_printv("Patching image crc from %x to %x\n", *kwboot_img_csum32_ptr(img), kwboot_img_csum32(img) );
+                       *kwboot_img_csum32_ptr(img) = kwboot_img_csum32(img);
+               }
+               else 
+               {
+                   goto err;
+               }
+       }
        is_secure = kwboot_img_is_secure(img);
 
        if (hdr->blockid != IBR_HDR_UART_ID) {
@@ -1654,6 +1663,7 @@
        fprintf(stream, "  -s <resp-timeo>: use specific response-timeout\n");
        fprintf(stream,
                "  -o <block-timeo>: use specific xmodem block timeout\n");
+       fprintf(stream, "  -f: fix crc\n");
        fprintf(stream, "\n");
        fprintf(stream, "  -t: mini terminal\n");
        fprintf(stream, "\n");
@@ -1689,7 +1699,7 @@
        kwboot_verbose = isatty(STDOUT_FILENO);
 
        do {
-               int c = getopt(argc, argv, "hb:ptaB:dD:q:s:o:");
+               int c = getopt(argc, argv, "hb:ptaB:dD:q:s:o:f");
                if (c < 0)
                        break;
 
@@ -1737,6 +1747,9 @@
                        baudrate = atoi(optarg);
                        break;
 
+               case 'f':
+                       fix_crc = 1;
+                       break;
                case 'h':
                        rv = 0;
                default:
